
"""Start-up module for lambda-calculus reducer
"""

######################################################################
### START-UP CODE #####################################################

import sys
import Format
import Eval


try :
    import os
    cwd = os.getcwd()     # get current working dir
    if os.path.basename(cwd) == "Lambda" : # is cwd the folder where this pgm lives?
        # then, move up one level; don't want to deposit junk here!
        os.chdir(os.pardir)
    print "Current path is ", os.getcwd()

    expression = ""   # input expression to reduce
    if len(sys.argv) >= 2 :   # command-line argument ?
        filename = sys.argv[1]
    else : 
        filename = raw_input("Type filename (relative to current path) to eval: ")

    while True :   # eval loop:
        expression = Format.initialize(filename)
        while expression == "":  # only defs in  filename ?  
            rawexpr = raw_input("Type expression to reduce, on one line only:\n").strip()
            if rawexpr != "" :  
                expression = Format.toETREE(rawexpr)
        print "Reduce: ", expression
        print             
        Eval.eval(expression)
        Format.finalize()
        repeat = raw_input("Press  Enter  to repeat; Press  q  to quit: ")
        if repeat == "q" : break

except:  # an error:
   import traceback
   traceback.print_exc()

# Finished.

